package me.unurled.sacredrealms.sr.commands.admin.cutscene;

import io.papermc.paper.command.brigadier.BasicCommand;
import io.papermc.paper.command.brigadier.CommandSourceStack;
import java.util.Collection;
import me.unurled.sacredrealms.sr.Manager;
import me.unurled.sacredrealms.sr.components.cutscene.RecordingManager;
import me.unurled.sacredrealms.sr.utils.component.TranslatedComponent;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

public class StopRecordingCommand implements BasicCommand {

  @Override
  public void execute(@NotNull CommandSourceStack stack, String[] args) {
    if (!(stack.getSender() instanceof Player p)) {
      stack.getSender().sendMessage(TranslatedComponent.NOT_PLAYER.component());
      return;
    }
    if (!p.hasPermission("sr.cutscene.create")) {
      p.sendMessage(TranslatedComponent.NO_PERMISSION.component());
      return;
    }

    Manager.getInstance(RecordingManager.class).stopRecording(p);
  }

  @Override
  public Collection<String> suggest(CommandSourceStack commandSourceStack, String[] args) {
    return BasicCommand.super.suggest(commandSourceStack, args);
  }
}
