package me.unurled.sacredrealms.sr.components.translation;

import java.util.Locale;
import java.util.ResourceBundle;
import me.unurled.sacredrealms.sr.Manager;
import net.kyori.adventure.key.Key;
import net.kyori.adventure.translation.GlobalTranslator;
import net.kyori.adventure.translation.TranslationRegistry;
import net.kyori.adventure.util.UTF8ResourceBundleControl;

public class TranslationManager extends Manager {
  private TranslationRegistry registry;

  @Override
  public void load() {
    super.load();
    registry = TranslationRegistry.create(Key.key("sr:translations"));
    ResourceBundle bundle =
        ResourceBundle.getBundle("sr.Bundle", Locale.US, UTF8ResourceBundleControl.get());
    registry.registerAll(Locale.US, bundle, true);
    GlobalTranslator.translator().addSource(registry);
  }

  @Override
  public void unload() {
    super.unload();
    GlobalTranslator.translator().removeSource(registry);
  }
}
