package me.unurled.sacredrealms.sr.gui.difficulty;

import static me.unurled.sacredrealms.sr.utils.Items.cancelItem;
import static me.unurled.sacredrealms.sr.utils.Items.glassPane;

import me.unurled.sacredrealms.sr.components.difficulty.Difficulty;
import org.jetbrains.annotations.NotNull;
import xyz.xenondevs.invui.gui.Gui;
import xyz.xenondevs.invui.gui.Gui.Builder;
import xyz.xenondevs.invui.item.Item;

public class DifficultyGUI {
  public static @NotNull Gui createGui() {
    Item cancel = Item.simple(cancelItem());
    Item glass = Item.simple(glassPane());
    Builder<?, ?> gui =
        Gui.builder()
            .setStructure(".........", "..1.2.3..", "....4....", "....5....")
            .addIngredient('5', cancel)
            .addIngredient('.', glass)
            .addIngredient('1', new DifficultyItem(Difficulty.EASY))
            .addIngredient('2', new DifficultyItem(Difficulty.NORMAL))
            .addIngredient('3', new DifficultyItem(Difficulty.HARD))
            .addIngredient('4', new DifficultyItem(Difficulty.INSANE));
    return gui.build();
  }
}
