package me.unurled.sacredrealms.sr.gui.difficulty;

import me.unurled.sacredrealms.sr.Manager;
import me.unurled.sacredrealms.sr.components.difficulty.Difficulty;
import me.unurled.sacredrealms.sr.components.player.PlayerManager;
import me.unurled.sacredrealms.sr.components.player.SRPlayer;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.ClickType;
import org.jetbrains.annotations.NotNull;
import xyz.xenondevs.invui.Click;
import xyz.xenondevs.invui.item.AbstractItem;
import xyz.xenondevs.invui.item.ItemBuilder;
import xyz.xenondevs.invui.item.ItemProvider;

public class DifficultyItem extends AbstractItem {

  private final Difficulty difficulty;

  public DifficultyItem(Difficulty difficulty) {
    this.difficulty = difficulty;
  }

  @Override
  public @NotNull ItemProvider getItemProvider(@NotNull Player viewer) {
    return switch (difficulty) {
      case EASY ->
          new ItemBuilder(Material.BREAD)
              .setCustomName("Easy")
              .addLoreLines(
                  "Is you are a new player or",
                  "someone who just want to",
                  "enjoy the game without " + "grinding too much",
                  "",
                  "Click Here!");
      case NORMAL ->
          new ItemBuilder(Material.GRASS_BLOCK)
              .setCustomName("Normal")
              .addLoreLines(
                  "Is you are a regular player",
                  "who want to enjoy the game",
                  "without too much grinding",
                  "",
                  "Click Here!");
      case HARD ->
          new ItemBuilder(Material.DIAMOND_SWORD)
              .setCustomName("Hard")
              .addLoreLines(
                  "Is you are a hardcore player",
                  "who want to enjoy the game",
                  "with some grinding",
                  "",
                  "Click Here!");
      case INSANE ->
          new ItemBuilder(Material.NETHERITE_SWORD)
              .setCustomName("Insane")
              .addLoreLines(
                  "Is you are a pro player",
                  "who want to enjoy the game",
                  "with a lot of grinding",
                  "some things are hidden very well here...",
                  "",
                  "Click Here!");
    };
  }

  @Override
  public void handleClick(
      @NotNull ClickType clickType, @NotNull Player player, @NotNull Click click) {
    PlayerManager pm = Manager.getInstance(PlayerManager.class);
    if (pm.isSRPlayer(player.getUniqueId())) {
      SRPlayer sr = pm.getPlayer(player.getUniqueId());
      if (sr != null) {
        sr.setDifficulty(difficulty);
        player.closeInventory();
        player.sendMessage("Set difficulty to " + difficulty.name() + "!");
      }
    }
  }
}
