package me.unurled.sacredrealms.sr.gui.entitytype;

import static me.unurled.sacredrealms.sr.utils.Items.name;

import java.util.ArrayList;
import java.util.List;
import me.unurled.sacredrealms.sr.components.entity.SREntityType;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.inventory.ItemStack;
import org.jetbrains.annotations.NotNull;
import xyz.xenondevs.invui.Click;
import xyz.xenondevs.invui.item.AbstractItem;
import xyz.xenondevs.invui.item.ItemBuilder;
import xyz.xenondevs.invui.item.ItemProvider;

public class EntityArmorItem extends AbstractItem {

  private static final ItemStack MAINHAND = name(new ItemStack(Material.BARRIER), "Main Hand");
  private static final ItemStack SECONDHAND = name(new ItemStack(Material.BARRIER), "Off Hand");
  private static final List<ItemStack> ARMOR = new ArrayList<>();
  private final ItemStack stack;

  public EntityArmorItem(@NotNull SREntityType type, int armorSlot) {

    ARMOR.add(name(new ItemStack(Material.BARRIER), "Helmet"));
    ARMOR.add(name(new ItemStack(Material.BARRIER), "Chestplate"));
    ARMOR.add(name(new ItemStack(Material.BARRIER), "Leggings"));
    ARMOR.add(name(new ItemStack(Material.BARRIER), "Boots"));

    switch (armorSlot) {
      case 4 -> {
        if (type.getHandItem().getType().equals(Material.AIR)) {
          stack = MAINHAND;
        } else {
          stack = type.getHandItem();
        }
      }
      case 5 -> {
        if (type.getSecondHandItem().getType().equals(Material.AIR)) {
          stack = SECONDHAND;
        } else {
          stack = type.getSecondHandItem();
        }
      }
      default -> {
        if (type.getArmor().size() <= armorSlot
            || type.getArmor().get(armorSlot).getType().equals(Material.AIR)) {
          stack = ARMOR.get(armorSlot);
        } else {
          stack = type.getArmor().get(armorSlot);
        }
      }
    }
  }

  @Override
  public @NotNull ItemProvider getItemProvider(@NotNull Player viewer) {
    return new ItemBuilder(stack);
  }

  @Override
  public void handleClick(
      @NotNull ClickType clickType, @NotNull Player player, @NotNull Click click) {
    /* TODO need to implements this */
  }
}
