package me.unurled.sacredrealms.sr.gui.entitytype;

import java.util.Map;
import java.util.Map.Entry;
import me.unurled.sacredrealms.sr.components.attributes.Attribute;
import me.unurled.sacredrealms.sr.components.entity.SREntityType;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.ClickType;
import org.jetbrains.annotations.NotNull;
import xyz.xenondevs.invui.Click;
import xyz.xenondevs.invui.item.AbstractItem;
import xyz.xenondevs.invui.item.ItemBuilder;
import xyz.xenondevs.invui.item.ItemProvider;

public class EntityStatsItem extends AbstractItem {

  private final Map<Attribute, Double> attributes;

  public EntityStatsItem(SREntityType type) {
    attributes = type.getAttributes();
  }

  @Override
  public @NotNull ItemProvider getItemProvider(@NotNull Player viewer) {
    ItemBuilder builder = new ItemBuilder(Material.APPLE).setCustomName("Add Stats");
    for (Entry<Attribute, Double> entry : attributes.entrySet()) {
      builder.addLoreLines(entry.getKey().getName() + ": " + entry.getValue());
    }
    return builder;
  }

  @Override
  public void handleClick(
      @NotNull ClickType clickType, @NotNull Player player, @NotNull Click click) {
    /* TODO need to implements this */
  }
}
