package me.unurled.sacredrealms.sr.gui.entitytype;

import java.util.ArrayList;
import java.util.List;
import me.unurled.sacredrealms.sr.Manager;
import me.unurled.sacredrealms.sr.components.entity.EntityManager;
import me.unurled.sacredrealms.sr.components.entity.SREntityType;
import me.unurled.sacredrealms.sr.gui.BackItem;
import me.unurled.sacredrealms.sr.gui.ForwardItem;
import org.bukkit.Material;
import org.jetbrains.annotations.NotNull;
import xyz.xenondevs.invui.gui.Gui;
import xyz.xenondevs.invui.gui.Markers;
import xyz.xenondevs.invui.gui.PagedGui;
import xyz.xenondevs.invui.item.Item;
import xyz.xenondevs.invui.item.ItemBuilder;

public class EntityTypeGUI {
  private EntityTypeGUI() {}

  public static @NotNull Gui listGui() {
    EntityManager em = Manager.getInstance(EntityManager.class);
    List<Item> list = new ArrayList<>();
    for (SREntityType type : em.getTypes()) {
      Item simpleItem = Item.simple(new ItemBuilder(type.getItem()));
      list.add(simpleItem);
    }
    return PagedGui.itemsBuilder()
        .setStructure(
            "# # # # # # # # #",
            "# X X X X X X X #",
            "# X X X X X X X #",
            "# X X X X X X X #",
            "# # # < # > # # #")
        .addIngredient('X', Markers.CONTENT_LIST_SLOT_HORIZONTAL)
        .addIngredient('<', new BackItem())
        .addIngredient('>', new ForwardItem())
        .setContent(list)
        .build();
  }

  public static @NotNull Gui createGui(SREntityType type) {

    Item border =
        Item.simple(new ItemBuilder(Material.BLACK_STAINED_GLASS_PANE).setCustomName("§r"));

    return Gui.builder()
        .setStructure(
            "# # # # # # # # #",
            "# T V O I S N L #", // Type, behaVior, lOot, Item display, Stats, Name, Level
            "# X X X P X X X #", // exPerience
            "# H C E B X M A #", // Helmet, Chestplate, lEgging, Boots, Main hand, second hAnd
            "# # # # # # # # #")
        .addIngredient('#', border)
        .addIngredient('T', new EntityTypeItem(type))
        .addIngredient('V', new EntityBehaviorItem(type))
        .addIngredient('O', new EntityLootItem())
        .addIngredient('I', new EntityItemDisplay(type))
        .addIngredient('S', new EntityStatsItem(type))
        .addIngredient('N', new EntityNameItem(type))
        .addIngredient('L', new EntityLevelItem(type))
        .addIngredient('P', new EntityExpItem(type))
        .addIngredient('H', new EntityArmorItem(type, 0))
        .addIngredient('C', new EntityArmorItem(type, 1))
        .addIngredient('E', new EntityArmorItem(type, 2))
        .addIngredient('B', new EntityArmorItem(type, 3))
        .addIngredient('M', new EntityArmorItem(type, 4))
        .addIngredient('A', new EntityArmorItem(type, 5))
        .build();
  }
}
