package me.unurled.sacredrealms.sr.gui.recordings;

import static me.unurled.sacredrealms.sr.utils.Logger.error;
import static me.unurled.sacredrealms.sr.utils.component.Component.textComp;

import java.util.UUID;
import me.unurled.sacredrealms.sr.Manager;
import me.unurled.sacredrealms.sr.SR;
import me.unurled.sacredrealms.sr.components.cutscene.Cutscene;
import me.unurled.sacredrealms.sr.components.cutscene.CutsceneManager;
import me.unurled.sacredrealms.sr.components.cutscene.RecordingManager;
import org.bukkit.Material;
import org.bukkit.NamespacedKey;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.persistence.PersistentDataType;
import org.jetbrains.annotations.NotNull;
import xyz.xenondevs.invui.Click;
import xyz.xenondevs.invui.item.AbstractItem;
import xyz.xenondevs.invui.item.ItemBuilder;
import xyz.xenondevs.invui.item.ItemProvider;

public class CutsceneItem extends AbstractItem {

  private static NamespacedKey ID = null;
  private final String name;
  private final UUID uuid;

  public CutsceneItem(String name, UUID uuid) {
    this.name = name;
    this.uuid = uuid;
    ID = new NamespacedKey(SR.plugin(), "cutscene_id");
  }

  @Override
  public @NotNull ItemProvider getItemProvider(@NotNull Player viewer) {
    ItemStack itemStack = new ItemStack(Material.PAPER);
    ItemMeta itemMeta = itemStack.getItemMeta();
    itemMeta.displayName(textComp(name));
    itemMeta.getPersistentDataContainer().set(ID, PersistentDataType.STRING, uuid.toString());
    itemStack.setItemMeta(itemMeta);

    return new ItemBuilder(itemStack);
  }

  @Override
  public void handleClick(
      @NotNull ClickType clickType, @NotNull Player player, @NotNull Click click) {
    // get uuid
    error(
        "Click on CutsceneItem.java: "
            + this.uuid
            + " by "
            + player.getName()
            + " it may misfire or fire for the wrong cutscene, I am not sure about the uuid handling here.");
    Cutscene cutscene = Manager.getInstance(CutsceneManager.class).findByUUID(this.uuid);

    if (cutscene == null) {
      player.sendMessage(textComp("<red>Unexpected error."));
      return;
    }
    if (clickType.isLeftClick()) {
      Manager.getInstance(RecordingManager.class).startRecording(cutscene, player);
    }
  }
}
