package me.unurled.sacredrealms.sr.gui.treasure;

import static me.unurled.sacredrealms.sr.utils.Logger.log;
import static me.unurled.sacredrealms.sr.utils.component.Component.textComp;

import java.util.HashMap;
import java.util.Map;
import me.unurled.sacredrealms.sr.Manager;
import me.unurled.sacredrealms.sr.components.treasure.Treasure;
import me.unurled.sacredrealms.sr.components.treasure.TreasureManager;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.jetbrains.annotations.NotNull;
import xyz.xenondevs.invui.Click;
import xyz.xenondevs.invui.item.AbstractItem;
import xyz.xenondevs.invui.item.ItemBuilder;
import xyz.xenondevs.invui.item.ItemProvider;

public class ConfirmItem extends AbstractItem {

  private final Treasure treasure;

  public ConfirmItem(Treasure treasure) {
    this.treasure = treasure;
  }

  @Override
  public @NotNull ItemProvider getItemProvider(@NotNull Player viewer) {
    ItemStack confirm = new ItemStack(Material.GREEN_STAINED_GLASS_PANE);
    ItemMeta confirmMeta = confirm.getItemMeta();
    confirmMeta.displayName(textComp("<b><green>Confirm</green></b>"));
    confirm.setItemMeta(confirmMeta);
    return new ItemBuilder(confirm);
  }

  @Override
  public void handleClick(
      @NotNull ClickType clickType, @NotNull Player player, @NotNull Click click) {
    Map<Integer, ItemStack> items = new HashMap<>();
    for (int i = 0; i < player.getInventory().getContents().length; i++) {
      if (i < 9 || i > 35) {
        log("Skipping slot " + i);
        continue;
      }
      ItemStack content = player.getOpenInventory().getItem(i);
      if (content != null && content.getType() != Material.AIR) {
        items.put(i, content);
        log("Added item to items: " + content + " at slot " + i);
      }
    }
    log("Items: " + items);
    TreasureManager tm = Manager.getInstance(TreasureManager.class);
    tm.setBlocks(treasure.getId(), items);

    player.closeInventory();
  }
}
