package me.unurled.sacredrealms.sr.gui.treasure;

import static me.unurled.sacredrealms.sr.utils.component.Component.textComp;

import me.unurled.sacredrealms.sr.Manager;
import me.unurled.sacredrealms.sr.components.treasure.Treasure;
import me.unurled.sacredrealms.sr.components.treasure.TreasureManager;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.jetbrains.annotations.NotNull;
import xyz.xenondevs.invui.Click;
import xyz.xenondevs.invui.item.AbstractItem;
import xyz.xenondevs.invui.item.ItemBuilder;
import xyz.xenondevs.invui.item.ItemProvider;

public class DeleteItem extends AbstractItem {

  private final Treasure treasure;

  public DeleteItem(Treasure treasure) {
    this.treasure = treasure;
  }

  @Override
  public @NotNull ItemProvider getItemProvider(@NotNull Player viewer) {
    ItemStack delete = new ItemStack(Material.RED_STAINED_GLASS_PANE);
    ItemMeta deleteMeta = delete.getItemMeta();
    deleteMeta.displayName(textComp("<b><red>Delete</red></b>"));
    delete.setItemMeta(deleteMeta);
    return new ItemBuilder(delete);
  }

  @Override
  public void handleClick(
      @NotNull ClickType clickType, @NotNull Player player, @NotNull Click click) {
    // delete treasure
    if (!player.hasPermission("sr.treasure.delete")) {
      return;
    }
    TreasureManager treasureManager = Manager.getInstance(TreasureManager.class);
    treasureManager.removeTreasure(treasure);
    player.sendMessage(textComp("<red>Treasure deleted!"));
    player.closeInventory();
  }
}
